import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Ilya Peresadin <pva701@gmail.com>
 * @created 27.09.16
 */
public class numrecovery_ip_tl_brute implements Closeable {

    FastScanner in;
    PrintWriter out;

    public numrecovery_ip_tl_brute() throws IOException {
        in = new FastScanner(new File("numrecovery.in"));
        out = new PrintWriter("numrecovery.out");
    }

    @Override
    public void close() throws IOException {
        out.close();
    }

    private int pow10(int x) {
        int ret = 1;
        for (int i = 1; i <= x; ++i) {
            ret *= 10;
        }
        return ret;
    }

    private int cntQ(String s) {
        int ret = 0;
        for (int i = 0; i < s.length(); ++i)
            if (s.charAt(i) == '?') {
                ret++;
            }
        return ret;
    }

    private int cntWays(String str, boolean isRig) {
        if (str.charAt(0) == '?' && isRig) {
            return pow10(cntQ(str.substring(1))) * 9;
        } else {
            return pow10(cntQ(str));
        }
    }

    private int[] lSort(int[] a) {
        Arrays.sort(a);
        return a;
    }

    private int[] rSort(int[] a, int pw, int m) {
        for (int i = 0; i < a.length; ++i) {
            a[i] = (int)((long) a[i] * pw % m);
        }
        Arrays.sort(a);
        return a;
    }

    private String str;
    private int strlength;
    private boolean isRig;
    private int mod;
    private int mn = Integer.MAX_VALUE;

    private void recBrute(int pos, long val) {
        if (pos == strlength) {
            mn = (int)Math.min(mn, val % mod);
            return;
        }
        if (str.charAt(pos) == '?') {
            for (int d = (isRig && pos == 0 && strlength != 1 ? 1 : 0); d < 10; ++d) {
                recBrute(pos + 1, val * 10 + d);
            }
        } else {
            recBrute(pos + 1, val * 10 + (str.charAt(pos) - '0'));
        }
    }

    public void run() {
        String s = in.next();
        int m = in.nextInt();
        this.mod = m;
        this.str = s;
        this.isRig = true;
        this.strlength = str.length();
        recBrute(0, 0);
        out.println(mn);
    }

    public static void main(String[] args) throws IOException {
        numrecovery_ip_tl_brute instance = new numrecovery_ip_tl_brute();
        instance.run();
        instance.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
