#define _ijps 0
#define _CRT_SECURE_NO_DEPRECATE
//#pragma comment(linker, "/STACK:667772160")
#include <iostream>
#include <cmath>
#include <vector>
#include <time.h>
#include <map>
#include <set>
#include <deque>
#include <cstdio>
#include <cstdlib>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <string>
#include <fstream>
#include <assert.h>
#include <list>
#include <cstring>
#include <queue>
using namespace std;

#define name "array"
typedef unsigned long long ull;
typedef long long ll;
#define mk make_pair
#define forn(i, n) for(int i = 0; i < (int)n; i++)
#define fornn(i, q, n) for(ll i = (ll)q; i < (ll)n; i++)
#define times clock() * 1.0 / CLOCKS_PER_SEC

struct __isoff{
	__isoff(){
		if (_ijps)
			freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);//, freopen("test.txt", "w", stderr);
		else freopen(name".in", "r", stdin), freopen(name".out", "w", stdout);
		//ios_base::sync_with_stdio(0);
		//srand(time(0));
		srand('C' + 'T' + 'A' + 'C' + 'Y' + 'M' + 'B' + 'A');
	}
	~__isoff(){
		//if(_ijps) cout<<times<<'\n';
	}
} __osafwf;
const ull p1 = 131;
const ull p2 = 129;
const double eps = 1e-8;
const double pi = acos(-1.0);

const int infi = 1e9 + 7;
const ll inf = 1e18 + 7;
const ll dd = 1e6 + 7;
const ll mod = 1e9 + 7;

struct ev{
	int l, r;
	int a, b;
	int type;
	ev(int l, int r, int a, int b, int type) : l(l), r(r), a(a), b(b), type(type){

	}
	ev(){
		l = r = a = b = type = -1;
	}
};

struct block{
	int l, r, type;
	vector<int> C;
	block(int l, int r, int type) : l(l), r(r), type(type){

	}
	int getSize(){
		return r - l + 1;
	}
	block(){
		l = r = type = 0;
	}
};

vector<int> G, P, Block;
vector<block> Type;
vector<ev> Events;
int n, m;

int getBlockIndex(int x){
	int s = -1;
	forn(i, Block.size()){
		s += Type[Block[i]].getSize();
		if(s == x){
			return i;
		}
	}
	assert(0);
	return -1;
}

void split(int x){
	int s = -1, type = -1, f = 0, e = -1;
	forn(i, Block.size()){
		if(s + Type[Block[i]].getSize() == x){
			return;
		}
		if(s + Type[Block[i]].getSize() > x){
			type = Block[i];
			f = x - s - 1;
			e = i;
			break;
		}
		s += Type[Block[i]].getSize();
	}
	Type.push_back(block(Type[type].l, Type[type].l + f, Type.size()));
	Type.push_back(block(Type[type].l + f + 1, Type[type].r, Type.size()));
	vector<int> BlockTemp;
	int ee = 0;
	forn(i, Block.size()){
		if(Block[i] == type){
			ee++;
			assert(ee <= 1);
			BlockTemp.push_back((int)Type.size() - 2);
			BlockTemp.push_back((int)Type.size() - 1);
		}
		else{
			BlockTemp.push_back(Block[i]);
		}
	}
	Block = BlockTemp;
}

void swap(int l, int r, int a, int b){
	if(l > a){
		swap(l, a);
		swap(r, b);
	}
	l = getBlockIndex(l - 1) + 1;
	r = getBlockIndex(r) + 1;
	a = getBlockIndex(a - 1) + 1;
	b = getBlockIndex(b) + 1;
	vector<int> BlockTemp = Block;

	BlockTemp.erase(BlockTemp.begin() + a, BlockTemp.begin() + b);
	BlockTemp.insert(BlockTemp.begin() + a, Block.begin() + l, Block.begin() + r);

	BlockTemp.erase(BlockTemp.begin() + l, BlockTemp.begin() + r);
	BlockTemp.insert(BlockTemp.begin() + l, Block.begin() + a, Block.begin() + b);

	Block = BlockTemp;
}

vector<int> C;

void StupidSwap(int l, int r, int a, int b){
	if(l > a){
		swap(l, a);
		swap(r, b);
	}
	r++, b++;
	vector<int> BlockTemp = C;
	BlockTemp.erase(BlockTemp.begin() + a, BlockTemp.begin() + b);
	BlockTemp.insert(BlockTemp.begin() + a, C.begin() + l, C.begin() + r);

	BlockTemp.erase(BlockTemp.begin() + l, BlockTemp.begin() + r);
	BlockTemp.insert(BlockTemp.begin() + l, C.begin() + a, C.begin() + b);
	C = BlockTemp;
}



vector<int> getGood(){
	vector<int> F;
	forn(i, Block.size()){
		int t = Block[i];
		for(int j = Type[t].l; j <= Type[t].r; j++){
			F.push_back(P[j]);
		}
	}
	return F;
}
vector<int> getBad(){
	return C;
}

void print(vector<int> P){
	forn(i, P.size()){
		cout << P[i] << ' ';
		cerr << P[i] << ' ';
	}
	cerr << '\n';
	cout << '\n';
}

ll mrand(){
	return (rand() * 1ll) ^ (rand() * 1ll << 16ll);
}

int Get(int l, int r, int a, int b){
	l = getBlockIndex(l - 1) + 1;
	r = getBlockIndex(r);
	int res = 0;
	for(int i = l; i <= r; i++){
		res += upper_bound(Type[Block[i]].C.begin(), Type[Block[i]].C.end(), b) - lower_bound(Type[Block[i]].C.begin(), Type[Block[i]].C.end(), a);
	}
	return res;
}


int main(){
	cin >> n >> m;
	P.resize(n);
	forn(i, n){
		scanf("%d", &P[i]);
	}
	C = P;
	Type.push_back(block(0, n - 1, 0));
	Block.push_back(0);
	forn(i, m){
		int type;
		int l, r, a, b;

		if(0){
			int s = mrand() % n / 3 + 1;
			l = mrand() % (n - s + 1) + 1;
			r = l + s - 1;

			a = mrand() % (n - s + 1) + 1;
			b = a + s - 1;

			while(max(l, a) <= min(b, r)){
				a = mrand() % (n - s + 1) + 1;
				b = a + s - 1;
			}
		}

		cin >> type >> l >> r >> a >> b;

		l--, r--;
		split(l - 1);
		split(r);
		if(type == 1){
			assert(r - l == b - a);
			a--, b--;
			split(a - 1);
			split(b);
			swap(l, r, a, b);
			//StupidSwap(l, r, a, b);
		}
		Events.push_back(ev(l, r, a, b, type));
		if(0){
			//print(getGood());
			//print(getBad());
			if(getBad() != getGood()){
				cout << "FUCK\n";
				return 0;
			}
		}
	}
	if(0){
		cout << Block.size() << ' ' << Type.size() << '\n';
		//print(getGood());
	}
	sort(Block.begin(), Block.end(), [](int a, int b){
		if(Type[a].l == Type[b].l){
			   return Type[a].r < Type[b].r;
		}
		return Type[a].l < Type[b].l;
	});
	forn(i, Block.size()){
		int t = Block[i];
		for(int j = Type[t].l; j <= Type[t].r; j++){
			Type[t].C.push_back(P[j]);
		}
		sort(Type[t].C.begin(), Type[t].C.end());
	}
	forn(i, m){
		int type = Events[i].type;
		int l = Events[i].l, r = Events[i].r, a = Events[i].a, b = Events[i].b;

		if(type == 1){
			swap(l, r, a, b);
		}
		else{
			cout << Get(l, r, a, b) << '\n';
		}
	}
}