import random
random.seed("basic04/crosswords")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(['internet', 'ifmo', 'rampage', 'olympiad'])

    def generate_min_tests(self):
        self.print_test(['aa', 'ab', 'ba', 'bb'])
        self.print_test(['aa', 'ab', 'ba', 'baa'])
        self.print_test(['aa', 'ab', 'ba', 'aab'])
        self.print_test(['aa', 'ab', 'ba', 'baab'])
        self.print_test(['aaa', 'aab', 'bab', 'baa'])

    def generate_hand_tests(self):
        self.print_test(['university', 'itmo', 'sharaga', 'triggered'])
        self.print_test(['university', 'itmo', 'sharaga', 'demotivator'])
        self.print_test(['crossword', 'square', 'formation', 'something'])
        self.print_test(['ahaha', 'ihihi', 'hehehe', 'ohoho'])
        self.print_test(['phenomenon', 'remuneration', 'particularly', 'pronunciation'])

    def generate_random_test(self, maxn):
        h = random.randint(2, maxn)
        w = random.randint(2, maxn)
        a = ''
        for i in range(h):
            a += chr(random.randint(0, 25) + ord('a'))
        c1 = a[0]
        c4 = a[-1]
        add = random.randint(0, maxn - len(a))
        for i in range(add):
            a = chr(random.randint(0, 25) + ord('a')) + a
        add = random.randint(0, maxn - len(a))
        for i in range(add):
            a += chr(random.randint(0, 25) + ord('a'))

        b = c1
        for i in range(w - 1):
            b += chr(random.randint(0, 25) + ord('a'))
        c2 = b[-1]
        add = random.randint(0, maxn - len(b))
        for i in range(add):
            b = chr(random.randint(0, 25) + ord('a')) + b
        add = random.randint(0, maxn - len(b))
        for i in range(add):
            b += chr(random.randint(0, 25) + ord('a'))

        c = c2
        for i in range(h - 1):
            c += chr(random.randint(0, 25) + ord('a'))
        c3 = c[-1]
        add = random.randint(0, maxn - len(c))
        for i in range(add):
            c = chr(random.randint(0, 25) + ord('a')) + c
        add = random.randint(0, maxn - len(c))
        for i in range(add):
            c += chr(random.randint(0, 25) + ord('a'))

        d = c4
        for i in range(w - 2):
            d += chr(random.randint(0, 25) + ord('a'))
        d += c3
        add = random.randint(0, maxn - len(d))
        for i in range(add):
            d = chr(random.randint(0, 25) + ord('a')) + d
        add = random.randint(0, maxn - len(d))
        for i in range(add):
            d += chr(random.randint(0, 25) + ord('a'))
        self.print_test([a, b, c, d])

    def generate_max_tests(self, maxn):
        a = 'a' * (maxn - 2) + 'ba'
        b = 'b' * (maxn - 2) + 'ab'
        c = 'ab' + 'a' * (maxn - 2)
        d = 'a' * (maxn - 1) + 'b'
        self.print_test([a, b, c, d])

    def print_test(self, words):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print('\n'.join(words), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 15, 20, 25, 26, 27, 28, 29, 30]
        for n in ns:
            self.generate_random_test(n)
            self.generate_random_test(n)
            self.generate_random_test(n)
        self.generate_max_tests(30)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
