#include <bits/stdc++.h>

using namespace std;

int solve(vector<int> a) {
	int n = a.size();
	vector<int> vct;
	vector<int> mx(2 * n, 1);
	int ans = 0;
	for (int i = 0; i < n * 2; i++) {
		while (!vct.empty() && a[i % n] > a[vct.back() % n]) {
			mx[i] = max(mx[i], mx[vct.back()] + 1);
			vct.pop_back();
		}
		ans = max(ans, mx[i]);
		vct.push_back(i);
	}
	return ans;
}

int slowsolve(vector<int> a) {
	int n = a.size();
	int ans = 0;
	for (int it = 0; it < n; it++) {
		vector<int> mx(n);
		vector<int> vct;
		for (int i = 0; i < n; i++) {
			mx[i] = 1;
			while (!vct.empty() && a[vct.back()] < a[i]) {
				mx[i] = max(mx[i], mx[vct.back()] + 1);
				vct.pop_back();
			}
			vct.push_back(i);
		}
		for (int i = 0; i < n; i++) ans = max(ans, mx[i]);
		rotate(a.begin(), a.begin() + 1, a.end());
	}
	return ans;
}

void stress() {
	for (int it = 0;; it++) {
		if (it % 100 == 0) cerr << it << endl;
		srand(it);
		int n = rand() % 100 + 1;
		vector<int> a(n);
		for (int i = 0; i < n; i++) a[i] = rand() % n + 1;
		int ans1 = solve(a);
		int ans2 = slowsolve(a);
		if (ans1 != ans2) {
			cerr << ans1 << " instead of " << ans2 << endl;
			cerr << n << endl;
			for (int i = 0; i < n; i++) cerr << a[i] << " \n"[i + 1 == n];
			slowsolve(a);
			solve(a);
			exit(0);
		}
	}
}

int main() {
	freopen("deepcycle.in", "r", stdin);
	freopen("deepcycle.out", "w", stdout);

	//stress();

	int n;
	scanf("%d", &n);
	vector<int> a(n);
	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
	printf("%d\n", slowsolve(a));

	return 0;
}