import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Ilya Peresadin <pva701@gmail.com>
 * @created 27.09.16
 */
public class numrecovery_ip_tl_sort implements Closeable {

    FastScanner in;
    PrintWriter out;

    public numrecovery_ip_tl_sort() throws IOException {
        in = new FastScanner(new File("numrecovery.in"));
        out = new PrintWriter("numrecovery.out");
    }

    @Override
    public void close() throws IOException {
        out.close();
    }

    private int pow10(int x) {
        int ret = 1;
        for (int i = 1; i <= x; ++i) {
            ret *= 10;
        }
        return ret;
    }

    private int cntQ(String s) {
        int ret = 0;
        for (int i = 0; i < s.length(); ++i)
            if (s.charAt(i) == '?') {
                ret++;
            }
        return ret;
    }

    private int cntWays(String str, boolean isRig) {
        if (str.length() != 0 && str.charAt(0) == '?' && isRig) {
            return pow10(cntQ(str.substring(1))) * 9;
        } else {
            return pow10(cntQ(str));
        }
    }

    private int[] lSort(int[] a) {
        Arrays.sort(a);
        return a;
    }

    private int[] rSort(int[] a, int pw, int m) {
        long l1t = System.currentTimeMillis();
        for (int i = 0; i < a.length; ++i) {
            a[i] = (int)((long) a[i] * pw % m);
        }
        Arrays.sort(a);
        long r1t = System.currentTimeMillis();
        System.out.println("rsort = " + (r1t - l1t) / 1000.0);
        return a;
    }

    private String str;
    private int strlength;
    private boolean isRig;
    private int[] ret;
    private int sz;
    private int mod;

    private int[] brute(String str, int m, boolean isRig) {
        this.isRig = isRig;
        this.str = str;
        this.strlength = str.length();
        this.ret = new int[cntWays(str, isRig)];
        this.sz = 0;
        this.mod = m;
        recBrute(0, 0);
        return ret;
    }

    private void recBrute(int pos, int val) {
        if (pos == strlength) {
            ret[sz++] = val % mod;
            return;
        }
        if (str.charAt(pos) == '?') {
            for (int d = (isRig && pos == 0 ? 1 : 0); d < 10; ++d) {
                recBrute(pos + 1, val * 10 + d);
            }
        } else {
            recBrute(pos + 1, val * 10 + (str.charAt(pos) - '0'));
        }
    }

    public void run() {
        long lt = System.currentTimeMillis();
        String s = in.next();
        int m = in.nextInt();
        int n = s.length();
        int[] rig = brute(s.substring(0, n / 2), m, true);
        int[] lef = brute(s.substring(n / 2, n), m, false);
        int pw = pow10((n + 1) / 2);
        lef = lSort(lef);
        rig = rSort(rig, pw % m, m);

        int mn = (lef[0] + rig[0]) % m, cr;
        for (int l = 0, r = rig.length - 2; l < lef.length; ++l) {
            for (; r >= 0 && lef[l] + rig[r] >= m; --r);
            cr = (lef[l] + rig[r + 1]) % m;
            if (cr < mn) {
                mn = cr;
            }
        }
        out.println(mn);
        long rt = System.currentTimeMillis();
        System.out.println("Total = " + (rt - lt) / 1000.0);
    }

    public static void main(String[] args) throws IOException {
        numrecovery_ip_tl_sort instance = new numrecovery_ip_tl_sort();
        instance.run();
        instance.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
